var vids;
var currentElements;

function GetSearchData(sUrl)
{
	Trace("Getting search data using url " + sUrl);
	loadXMLDoc(sUrl);
}

function GetFanData(fileName)
{
	if(fileName == undefined) fileName = currentFile;
	loadXMLDoc("http://www.comcast.net/data/thePlatform/" + fileName);
}
 
//loads xml and calls the xmlHttpChange function
function loadXMLDoc(url)
{
	Trace("Loading " + url);
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=xmlHttpChange;
	xmlhttp.open("GET",url,true);
	xmlhttp.send(null);
}
	
function xmlHttpChange()
{ //test
	// if xmlhttp shows "loaded"
	if (xmlhttp.readyState==4)
	{
		Trace("IMAGE PANE CHILDREN COUNT: " + imagePane.children.count);
		// if "OK"
		if (xmlhttp.status==200)
		{
			Clear();
		
			var xmlDoc=new DOMDocument;
			
			//load the document 
			xmlDoc.loadXML(xmlhttp.responseText);
			
			Trace("XML Document loaded.");
			
			Trace("XML: " + xmlDoc.xml);

			//check the reported count in the xml
			var reportedCount = xmlDoc.selectSingleNode("root").attributes.getNamedItem("count");
			
			if(reportedCount.nodeValue != "0")
			{
				
				//select all the video nodes
				var nodes = xmlDoc.selectNodes("root/video");
				
				Trace(nodes.length);

				//mark the length
				var len = nodes.length;
				
				var countFrom = 0;
				
				if(len > 0)
				{	
					countFrom = nodes.length-1;
					if(len > 100)
					{
						countFrom = 100;
					}
					vids = new Array(countFrom);

					for(i = countFrom; i >= 0; i--)
					{
						if(i == -1) break;
						try
						{
							Trace("Creating a new video class instance...");
							var vid = new Video(nodes.item(i));
							Trace("Video picture = " + vid.picture);
							var curImg = DownloadImage(vid.picture);
							Trace("Image instance created. Setting source.");							
							//render the image
							var element = RenderImage(curImg, i * 75, 0, i.toString());
							Trace("ELEMENT NAME: " + element.name);
							vids[i] = vid;
							vid.element = element;
						}
						catch(er)
						{
							Trace("Error in xmlHttpChange: " + er);
						}
					}
				}
				imagePane.width = (countFrom * 75);
				HideFeedback();
			}
			else
			{
				ShowFeedback("Sorry...there were no videos returned.");
				HideAndLoad();
			}
		}
	}
	txtSearch.enabled = true;
	txtSearch.value = searchTerm;
}

//
//renders an image to the display div
//
function RenderImage(stream, x, y, name)
{
	var img = imagePane.appendElement("<button onmousemove='ImageMouseMove();' onclick='ImageClicked();' onmouseover='ImageMouseOver()' onmouseout='ImageMouseOut()' image='ComcastIconTop.jpg' overImage='ComcastIconTop.jpg' cursor='hand' downImage='ComcastIconTop.jpg' x='"+ x +"' y='"+ y +"' name='"+ name +"'/>");
	img.image = stream;
	img.overImage = stream;
	img.downImage = stream;
	return img;
}

//
//clears out the image/button elements in the imagePane div 
//
function ClearExistingElements()
{	
	Trace("Iterating through the vids array to remove existing elements from the imagePane...");
	try
	{
		for(var i = 0;i < vids.length; i++)
		{
			Trace("Removing element " + vids[i].element.name);
			imagePane.removeElement(vids[i].element);
		}
	}
	catch(er)
	{
		Trace("[ClearExistingElements()] " + er);
	}
}

//
//Downloads an image and returns the response stream
//
function DownloadImage(url)
{
	var ret;
	try
	{
		Trace("Loading image " + url);
		var req = new XMLHttpRequest();
		var response = req.open("GET", url, false);
		req.send();
		//load the downloaded image into something google can use
		ret = req.responseStream;
		Trace("Image loaded.");
	}
	catch(er)
	{
		Trace("Loading the default image...");
		//use a default image if one does not come back
		ret = gadget.storage.openStream("ComcastIconTop.jpg");
		Trace("Default image loaded.");
	}
	return ret;
}

//
//called whenever a user clicks on a thumbnail.  this will luanch the appropriate fan video.
//
function ImageClicked()
{
	Trace("Test");
	Trace("ImageClicked() sourceid:" + vids[event.srcElement.name].id);
	gotoFan(vids[event.srcElement.name].id);
}

function ImageMouseOver()
{
	//txtDisplay.innerText = vids[event.srcElement.name].description;
	txtTitle.innerText = vids[event.srcElement.name].name;
	Trace(vids[event.srcElement.name].name);
	txtPopup.innerText =  vids[event.srcElement.name].description;
	ShowPopup();
}

function ShowPopup()
{
	divToolTip.visible = true;
}

function HidePopup()
{
	divToolTip.visible = false;
}

//
//floats the synopsis bubble around as the user floats the pointer over the display.
//
function ImageMouseMove()
{
	var x = event.x + event.srcElement.x - 45 + imagePane.x;
	Trace(event.y);
	//if the bubble is within the bounds of the display show it wherever...if not, freeze it at the x edes
	if(x > 7 && x < 279)
		divToolTip.x = x;
	else
	{
		if(x < 7)
			divToolTip.x = 7;
		if(x > 279)
			divToolTip.x = 279;
	}
	
	//when the pointer crosses the middle of the thumbnail, rotate the bubble image 180 degrees.
	if(event.y > 24)
	{
		divTipBubble.rotation = 180;
		divToolTip.y = event.y + -40;		
	}
	else
	{
		divTipBubble.rotation = 0;
		divToolTip.y = event.y + event.srcElement.y + 60;
	}	
}

function ImageMouseOut()
{
	txtDisplay.innerText = '';
	HidePopup();
}

function gotoFan(videoID)
{
	var WshShell = new ActiveXObject("WScript.Shell");
	WshShell.Run("http://www.comcast.net/providers/fan/popup.html?viewmode=fullScreenMode&v=" +videoID + "&pl=" + currentFile);
}
