var currentFile = "newest.xml";
var http;
var animator;
var leftStopPoint;
var move = 0;
var searchTerm;

//
//called by the framework when the gadget loads
//
function view_onOpen()
{
	Trace("Bulding the menu...");
	BuildMenu();
	Trace("Menu Built. Getting fan data...");
	GetFanData("newest.xml");
	Trace("Fan data loaded.");
	StartRefreshTimer();
	HideFeedback();
}

//
//scrolls the images in the display pane to the right by n panes
//
function ScrollRight(panelCount)
{
	Trace("Scrolling " + panelCount + " panels left...");
	if(imagePane.x != (imagePane.width - 75) * -1)
		imagePane.x -= (panelCount * 75);
	Trace("imagePane.x = " + imagePane.x);
}

//
//scrolls the images in the display pane to the left by n panes
//
function ScrollLeft(panelCount)
{
	if(imagePane.x < 0)
	{
		Trace("Scrolling " + panelCount + " panels right...");
		imagePane.x += (panelCount * 75);
		Trace("imagePane.x = " + imagePane.x);	
	}
}

//
//writes info out to the console
//
function Trace(val)
{
	if(val) 
		utils.log(gddLogLevelDebug, "trace", val);
	else
		utils.log(gddLogLevelDebug, "trace", "null reference");
} 


function MoveToEnd()
{
	Trace("DoubleClick");
	//turn off the buttons
	SetButtonState(false);
	animator = view.setInterval("Rewind()", 5); 
}

function MoveToBeginning()
{
	Trace("DoubleClick");
	SetButtonState(false);
	animator = view.setInterval("FastForward()", 5);
}

function Rewind()
{
	if(imagePane.x != 0)
	{
		imagePane.x += 75;
	}
	else
	{
		ResetAnimation();
	}
}

function FastForward()
{
	if(imagePane.width > 375)
	{
		if(imagePane.x != (imagePane.width - 75) * -1)
		{
			imagePane.x -= 75;
		}
		else
		{
			ResetAnimation()
		}
	}
}

//
//removes all of the panes and repositions main image display
//
function Clear()
{
	imagePane.width = 0;
	imagePane.x = 0;
	ClearExistingElements();
	ClearExistingElements();
} 

//
//starts the timer that calls home periodically for new videos
//
function StartRefreshTimer()
{
	//call home every half hour
	Trace("Calling home...");
	view.setInterval('GetFanData()', 1800000);
}

//
//starts the timer that calls AnimateRight- this will move the panes 5 to the right
//
function MoveRight()
{
	//disable the scroll buttons while animating
	leftStopPoint = (imagePane.width - 75) * -1;
	Trace("leftStopPoint = " + leftStopPoint);
	Trace("imagePane.x = " + imagePane.x);
	try
	{	
		if(imagePane.x > leftStopPoint)
		{
			SetButtonState(false);
			animator = setInterval('AnimateRight()', 10);
		}
	}
	catch(er)
	{
		Trace(er);
	}
}

//
//starts the timer that calls AnimateLeft- this will move the panes 5 to the left
//
function MoveLeft()
{
	//disable the scroll buttons while animating
	Trace("imagePane.x = " + imagePane.x);
	try
	{
		if(imagePane.x < 0)
		{
			SetButtonState(false);
			animator = setInterval('AnimateLeft()', 10);
		}
	}
	catch(er)
	{
		Trace(er);
	}
}

//
//slides all of the panes 5 to the right 5 pixels at a time
//
function AnimateRight()
{
	if(move == -375)
	{
		ResetAnimation();
	}
	else
	{
		move -= 25;
		imagePane.x -= 25;

		if(imagePane.x == leftStopPoint)
		{
			Trace("LEFT STOP POINT HIT.");
			ResetAnimation();
		}
	}
}

//
//slides the panes 5 to the left 5 pixels at a time
//
function AnimateLeft()
{	
	if(move == 375)
	{
		ResetAnimation();
	}
	else
	{
		move += 25;
		imagePane.x += 25;
		if(imagePane.x == 0)
		{
			ResetAnimation();
		}
	}
}

//
// resets the animation timer and the left/right buttons on the interface
//
function ResetAnimation()
{
	try
	{
		SetButtonState(true);
		Trace("Resetting the timer");
		Trace("x = " + imagePane.x);
		clearInterval(animator);
		move = 0;
	}
	catch(er)
	{
		Trace(er);
	}
}

//
//toggles the state of the left/right buttons on the interface
//
function SetButtonState(state)
{
	btnScrollLeft.enabled = state;
	btnScrollRight.enabled = state;
	btnPaneLeft.enabled = state;
	btnPaneRight.enabled = state;
}

function txtSearch_OnKeyPress()
{
	Trace("Search key pressed.");
	Trace("Key down.");
	Trace("View event " + view.event.keyCode);
	if(view.event.keyCode == '13')
	{
		Trace("Enter key detected.");
		startSearch();
	}
}

function Search()
{
	if(searchTerm != "")
	{
		//call the search function and load the panels
		GetSearchData("http://videosearch.comcast.net/ss-query/videosearch.jsp?f=1&q=" + searchTerm);
	}
	else
	{
		txtSearch.enabled = true;
		txtSearch.value = "";
	}
}

//
//sets ui cues and then kicks off the search process
//
function startSearch()
{
	Clear();
	searchTerm = trim(txtSearch.value);
	txtSearch.value = "Searching...";
	ShowFeedback("Loading videos...");
	txtSearch.enabled = false;
	view.setTimeout('Search();', 1000);
}

//
//downloads a file and stores it to the appdata directory of the current user
//
function StoreToCache(url, fileName)
{
	try
	{
		var oHTTP = new ActiveXObject("Microsoft.XMLHTTP"); 
		
		var sFullPath = GetTempDir() + "\\" + fileName;
		
		oHTTP.open("GET", url, false); 
		oHTTP.send(); 
		var oStream = new ActiveXObject("adodb.stream"); 
		var adTypeBinary = 1; 
		var adSaveCreateOverWrite = 2; 
		oStream.type = adTypeBinary; 
		oStream.open(); 
		oStream.write(oHTTP.responseBody); 
		oStream.savetofile(sFullPath, adSaveCreateOverWrite); 
		return sFullPath;
	}
	catch(er)
	{
		Trace(er);
	}
}

//
//gets the app data directory for the current user
//
function GetTempDir()
{
	var WshShell; 
	var env; 

	WshShell = new ActiveXObject("WScript.Shell"); 
	env=WshShell.Environment("Volatile");
	return env("AppData");
}

//
//Shows and autohides.
//
function ShowFeedback(feedback)
{
	txtFeedback.visible = true;
	if(feedback != undefined) txtFeedback.innerText = feedback;
}
//
//hides the feedback panel
//
function HideFeedback()
{
	Trace("Hiding feedback label.");
	txtFeedback.visible = false;
}

//
//hides the feedback panel and reloads the fan videos
//
function HideAndLoad()
{
	view.setTimeout('GetFanData();', 6000);
	view.setTimeout('HideFeedback();', 5500);
}

// Removes leading whitespaces
function LTrim( value ) {
	
	var re = /\s*((\S+\s*)*)/;
	return value.replace(re, "$1");
	
}

// Removes ending whitespaces
function RTrim( value ) {
	
	var re = /((\s*\S+)*)\s*/;
	return value.replace(re, "$1");
	
}

// Removes leading and ending whitespaces
function trim( value ) {
	
	return LTrim(RTrim(value));
	
}