var menuItems; //array of menuItem instances
var menuDictionary;  //associatve array of menuItem instances for name lookup
var menuDiv; //the actual div...once it is rendered we can toggle the visibility

//calls home to get the xml to build the category menu with.
//builds the menu and then populates the menuItems field for use
//in later calls to avoid calling back to the server
function BuildMenu()
{
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("GET","http://www.comcast.net/config/fan/menu.xml",false);
	xmlhttp.send(null);
	
	var items;
	//create the xml doc to hold the menu items
	var menuDoc = new DOMDocument();
	//get the menu items
	 menuDoc.loadXML(xmlhttp.responseText);
	
	Trace("Document loaded.");

	if(menuItems == undefined)
	{
		var items = menuDoc.selectNodes("list/item");
		menuItems = new Array(items.length);
		menuDictionary = new Array(items.length);
	
		Trace("Item count:" + items.length);
		for(var i = 0; i < items.length; i++)
		{
			var menuItem = new MenuItem(items[i]);
			menuDictionary[menuItem.name] = menuItem;
			menuItems[i] = menuItem;
		}
	}
	
	RenderMenu();
}

//
//class definition for the menu item
//
function MenuItem(menuNode)
{
	this.name = menuNode.attributes.getNamedItem("name").value;
	this.fileName = menuNode.attributes.getNamedItem("param").value;
}

//
//dynamically renders the menu div based on the genres/categories of content available for the comcast fan videos
//
function RenderMenu()
{
	Trace("Creating the menu div.");
	//derive the height
	var h = (menuItems.length * 12);
	
	//CREATE THE DIV	
	var menu = appendElement("<div onmouseout='ToggleMenu(false)' height='"+ h +"' width='88' visible='true' name='divMenu' x='165' y='28' background='#999999'/>");
	
	Trace("Appended the main menu.");
	
	//ADD EACH ITEM TO THE DIV
	for(var i = 0; i<menuItems.length; i++)
	{
		Trace("Menuitem name= " + menuItems[i].name);
		var y = (i * 12);
		Trace("Adding button... Y = " + y);
		var elementString = "<button x='0' y='"+ y.toString() +"' downImage='menu.png' onmouseover='MenuItemOver()' onmouseout='MenuItemOut()' image='menu.png' overImage='menuOver.png' name='"+ menuItems[i].name +"' onclick='MenuClicked()'/>"
		Trace("Element string = " + elementString);
		var item = menu.appendElement(elementString);
		//now add the label
		var labelString = "<label height='10' name='lbl"+menuItems[i].name+"' width='88' x='2' y='"+ y.toString() + "' font='Tahoma' size='7' color='#000000'>" + menuItems[i].name +"</label>"
		Trace("Label string = " + labelString);
		var lbl = menu.appendElement(labelString);		
	}	
	menuDiv = menu;
	menuDiv.visible = false;
}

//
//shows or hides the search bar based on the boolean 'show' parameter
//
function ShowSearchBar(show)
{
	ToggleMenu(false);
	imgSearchBox.visible = show;
	btnGo.visible = show;
	txtSearch.visible = show;
}

//
//changes the label of each menu item's text as the mouse moves over the menu item
//
function MenuItemOver()
{
	menuDiv.children.item("lbl" + event.srcElement.name).color = "#FFFFFF";
}

//
//changes the menu item text back to the original color as the mouse leaves the menu item.
//
function MenuItemOut()
{
	menuDiv.children.item("lbl" + event.srcElement.name).color = "#000000";
}

//
//fired whenever a user selects a genre of fan videos from the drop down
//
function MenuClicked()
{
	//hide the menu
	ToggleMenu(false);
	var curItem = menuDictionary[event.srcElement.name];
	Trace("MenuClicked: " + curItem.name);
	//set the label to reflect the current selection
	lblCurrent.innerText = curItem.name;
	//change the fan data file to reflect the selection
	currentFile = curItem.fileName;
	Trace("Set current file to " + currentFile);
	//clear the display out
	Clear();
	//load the fan data
	ShowFeedback("Loading videos...");
	view.setTimeout("GetFanData()", 400);
}

//
//toggles the visibiliity of the dropdown div
//
function ToggleMenu(visible)
{
	if(visible == undefined)
		var visible = (menuDiv.visible == false);
	
	Trace("Toggle Menu: " + visible);
	menuDiv.visible = visible;
}